#!/usr/bin/perl
use utf8; # Windowsで使うならこの行をコメントアウトする
use Encode qw/from_to/;
use Encode::Guess qw/euc-jp shiftjis 7bit-jis/;

# 1つの引数が必要
if(@ARGV != 1)
{
	die "usage\n$0 url\n"; # $0はプログラム名
}

$url = shift; # shiftで、@AEGVの先頭の引数を受け取る

# HTMLファイルを取得する。
open(FILE, "wget -q $url -O -|") or die "wget : $!";
@file = <FILE>;
close(FILE);
# 文字コードをUTF-8に変換する
$data = join("", @file);
$menc = guess_encoding($data);
ref($menc) or die "Can't guess: $menc"; # 自動判定に失敗したときのエラー処理
from_to($data, $menc->name, "utf-8"); # Windowsで使うならutf-8をshiftjisに変更

# タイトル名を取得
if($data =~ m/<title>([^<]*)/i)
{
	$dirName = $1;
	$dirName =~ s/^\s*(.*?)\s*$/$1/; # 前後の空白文字を削除
	$dirName =~ s/\&\w{2,8};/ /g; # html特殊文字をスペースを変換
	$dirName =~ s/[\/:*?"<>|]/_/g; # ディレクトリ名に使えない文字の置換
	print "$dirName\n";
}

# リンク抽出
while($data =~ m{a\b([^>]+)>}ig)
{
	my $Guts = $1;
	#print "$Guts\n";
	if($Guts =~ m{
					\b HREF
					\s* = \s*
					(?:
						"([^"]*)"
						|
						'([^']*)'
						|
						([^'">\s]+)
					)
				}xi)
	{
		my $linkurl = $+;
		if($linkurl =~ m{(?:jpg|gif|png|jpeg)$}i) # Downloadする拡張子はここで設定
		{
			print "$linkurl\n";
			push(@target, $linkurl);
		}
	}
}
# 抽出リンクがない場合終了する。
if($#target < 0)
{
	die("抽出すべきリンクがありません。\n");
}

# テンポラリディレクトリ名にUTCを利用する。
$tmp_dir = "gi_tmp".time();
mkdir ("./$tmp_dir", 0755) or die "ディレクトリ作成失敗 : $!";

# wgetでダウンロードする。
$wget = join("\n", @target);
open(OUT, "| wget -i - -P ./$tmp_dir");
print OUT $wget;
close(OUT);

# テンポラリディレクトリ名をHTMLタイトル名に変更する。
if(length($dirName))
{
	rename($tmp_dir, $dirName) or die "$!";
}
